/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2006 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: netapp.h,v 1.4 2007/11/09 00:39:45 abe Exp abe $
 */

#ifndef _NETAPP_H_
#define _NETAPP_H_

/*
 *  äȤĹ (LONGEST) ʤ (ULONGEST)
 */

#ifdef _int64_

typedef _int64_			LONGEST;
typedef unsigned _int64_	ULONGEST;

#else	/* of #ifdef _int64_ */

#ifdef _int32_

typedef _int32_			LONGEST;
typedef unsigned _int32_	ULONGEST;

#else	/* of #ifdef _int32_ */

typedef int			LONGEST;
typedef unsigned int		ULONGEST;

#endif	/* of #ifdef _int32_ */

#endif	/* of #ifdef _int64_ */

/*
 *  ФΥޥ
 */

#ifdef _int32_

#define GET_ARG(ap,lf)	 (lf ? va_arg(ap, _int32_) : va_arg(ap, int))

#else	/* of #ifdef _int32_ */

#define GET_ARG(ap,lf)	(va_arg(ap, int))

#endif	/* of #ifdef _int32_ */

/*
 *  IPv4  IPv6 ڴޥ
 */

#ifdef SUPPORT_INET4

#define PUT_IPADDR(p,a,w)	put_ipv4addr(p,a,w)

#endif	/* of #ifdef SUPPORT_INET4 */

#ifdef SUPPORT_INET6

#define PUT_IPADDR(p,a,w)	put_ipv6addr(p,a,w)

#endif	/* of #ifdef SUPPORT_INET6 */

/*
 *  󥽡Ѥ륷ꥢݡֹ
 */

#ifndef CONSOLE_PORTID

#define	CONSOLE_PORTID		LOGTASK_PORTID

#endif	/* of #ifndef CONSOLE_PORTID */

/*
 *  ѴΤѴɽ
 */

extern const char radhex[];
extern const char radHEX[];

/*
 *  ؿ
 */

extern UB *skip_blanks (UB *line);
extern int cons_getline (ID portid, UB *line, int size);
extern char *get_int (int *val, UB *line);
extern char *get_xuint (unsigned int *val, UB *line);
extern void cons_putchar (ID portid, char ch);
extern int cons_getchar (ID portid);
extern int cons_putnumber (ID portid, ULONGEST val, int radix,
                           const char *radchar, int width,
                           BOOL minus, char padchar);
extern void cons_printf (ID portid, const char *fmt, ...);
extern int put_macaddr (ID portid, UB *mac, int width);

#ifdef SUPPORT_INET4

extern int put_ipv4addr (ID portid, T_IN4_ADDR *addr, int width);

#endif	/* of #ifdef SUPPORT_INET4 */

#ifdef SUPPORT_INET6

extern int put_ipv6addr (ID portid, const T_IN6_ADDR *addr, int width);

#endif	/* of #ifdef SUPPORT_INET6 */

#endif	/* of #ifndef _NETAPP_H_ */
