/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2007 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: icmp6.h,v 1.4 2007/11/09 00:43:30 abe Exp abe $
 */

/*	$FreeBSD: src/sys/netinet/icmp6.h,v 1.2.2.3 2001/07/06 05:36:35 sumikawa Exp $	*/
/*	$KAME: icmp6.h,v 1.46 2001/04/27 15:09:48 itojun Exp $	*/

/*
 * Copyright (C) 1995, 1996, 1997, and 1998 WIDE Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Copyright (c) 1982, 1986, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)ip_icmp.h	8.1 (Berkeley) 6/10/93
 */

#ifndef _IP_ICMP6_H_
#define _IP_ICMP6_H_

#ifdef SUPPORT_INET6

/*
 *  ICMPv6 إå
 */

typedef struct t_icmp6_hdr {
	UB	type;		/* åη	*/
	UB	code;		/* ַ		*/
	UH	sum;		/* å		*/
	union {
		UW	data32;
		UH	data16[2];
		UB	data8[4];
		} data;
	} T_ICMP6_HDR;

#define icmp6_data32			data.data32
#define icmp6_data16			data.data16
#define icmp6_data8			data.data8
#define icmp6_pptr			data.data32		/* ѥ᡼۾	*/
#define icmp6_mtu			data.data32		/* ѥ᡼۾	*/
#define icmp6_id			data.data16[0]		/* ׵ȱ	*/
#define icmp6_seq			data.data16[1]		/* ׵ȱ	*/

#define ICMP6_HDR_SIZE			(sizeof(T_ICMP6_HDR))
#define IF_IP6_ICMP6_HDR_OFFSET		(IF_IP6_HDR_SIZE)

#define GET_ICMP6_HDR(nbuf,ihoff)	((T_ICMP6_HDR*)((UB*)((nbuf)->buf) + ihoff))
#define GET_ICMP6_SDU(nbuf,ihoff)	((UB*)((nbuf)->buf) + ihoff + ICMP6_HDR_SIZE)

#define GET_IP6_ICMP6_HDR_SIZE(nbuf)	(GET_IP6_HDR_SIZE(GET_IP6_HDR(nbuf)) + ICMP6_HDR_SIZE)
#define GET_IF_IP6_ICMP6_HDR_SIZE(nbuf)	(IF_HDR_SIZE + GET_IP6_ICMP6_HDR_SIZE(nbuf))

/*
 *  ICMP6 
 */

#define ICMP6_DST_UNREACH		1	/* ãԲǽ		*/
#define ICMP6_PACKET_TOO_BIG		2	/* ѥåȤ礭롣	*/
#define ICMP6_TIME_EXCEEDED		3	/* TTL Ķᤷ		*/
#define ICMP6_PARAM_PROB		4	/* IPv6 إå		*/

#define ICMP6_ECHO_REQUEST		128	/* ׵			*/
#define ICMP6_ECHO_REPLY		129	/* 			*/

#define ICMP6_MEMBERSHIP_QUERY		130	/* 롼ץоȲ		*/
#define ICMP6_MEMBERSHIP_REPORT		131	/* 롼ץ		*/
#define ICMP6_MEMBERSHIP_REDUCTION	132	/* 롼ץнλ		*/

#define MLD_LISTENER_QUERY		130	/* ޥ㥹ȼԾȲ	*/
#define MLD_LISTENER_REPORT		131	/* ޥ㥹ȼ	*/
#define MLD_LISTENER_DONE		132	/* ޥ㥹ȼԽλ	*/

#define ND_ROUTER_SOLICIT		133	/* 롼			*/
#define ND_ROUTER_ADVERT		134	/* 롼			*/
#define ND_NEIGHBOR_SOLICIT		135	/* 			*/
#define ND_NEIGHBOR_ADVERT		136	/* 			*/
#define ND_REDIRECT			137	/* ľ			*/

#define ICMP6_ROUTER_RENUMBERING	138	/* 롼ֹ		*/

#define ICMP6_WRU_REQUEST		139	/* ׵Ρõ		*/
#define ICMP6_WRU_REPLY			140	/* Ρõ		*/

#define ICMP6_FQDN_QUERY		139	/* FQDN Ȳ			*/
#define ICMP6_FQDN_REPLY		140	/* FQDN 			*/

#define ICMP6_NI_QUERY			139	/* ΡɾȲ		*/
#define ICMP6_NI_REPLY			140	/* Ρɾ		*/

#define ICMP6_MAX_TYPE			203	/* ICMP6 פκ		*/

/*
 *  ICMP6 
 */

/* ãԲǽ */

#define ICMP6_DST_UNREACH_NOROUTE	0	/* ã롼Ȥʤ		*/
#define ICMP6_DST_UNREACH_ADMIN		1	/* Ԥˤ̵档	*/
#define ICMP6_DST_UNREACH_NOTEIGHBOR	2	/* ټԤǤϤʤʤä	*/
#define ICMP6_DST_UNREACH_BEYOND_SCOPE	2	/* פĶƤ롣	*/
#define ICMP6_DST_UNREACH_ADDR		3	/* 襢ɥ쥹ãԲǽ	*/
#define ICMP6_DST_UNREACH_NOPORT	4	/* ݡȤãԲǽ	*/

/* TTL Ķ */

#define ICMP6_TIME_EXCEED_TRANSIT	0	/* ž TTL==0 ˤʤä	*/
#define ICMP6_TIME_EXCEED_REASSEMBLY	1	/* IP ƹǥॢȤ*/

/* إå */

#define ICMP6_PARAMPROB_HEADER		0	/* إåä	*/
#define ICMP6_PARAMPROB_NEXT_HEADER	1	/* إåǧǤʤ	*/
#define ICMP6_PARAMPROB_OPTION		2	/* ץǧǤʤ	*/

/*  */
#define ND_REDIRECT_ONLINK		0	/* 󥯤ؤθľ	*/
#define ND_REDIRECT_ROUTER		1	/* 롼ؤθľ		*/

/*
 *  
 */

						/* ICMPv6 κڥĹ	*/
#define ICMPV6_PAYLOAD_MAXLEN		(IPV6_MMTU - (IP6_HDR_SIZE + ICMP6_HDR_SIZE))

/*
 *  
 */

typedef struct t_neighbor_solicit_hdr {
	T_ICMP6_HDR	hdr;
	T_IN6_ADDR	target;
	/* θ˥ץ³ */
	} T_NEIGHBOR_SOLICIT_HDR;

#define NEIGHBOR_SOLICIT_HDR_SIZE	(sizeof(T_NEIGHBOR_SOLICIT_HDR))
#define IF_IP6_NEIGHBOR_SOLICIT_HDR_OFFSET	\
					(IF_IP6_HDR_SIZE)

#define GET_NEIGHBOR_SOLICIT_HDR(nbuf,nhoff)	\
					((T_NEIGHBOR_SOLICIT_HDR*)((UB*)((nbuf)->buf) + nhoff))
#define GET_NEIGHBOR_SOLICIT_SDU(nbuf,nhoff)	\
					((UB*)((nbuf)->buf) + nhoff + NEIGHBOR_SOLICIT_HDR_SIZE)

#define GET_IP6_NEIGHBOR_SOLICIT_HDR_SIZE(nbuf)		\
					(GET_IP6_HDR_SIZE(GET_IP6_HDR(nbuf)) + NEIGHBOR_SOLICIT_HDR_SIZE)
#define GET_IF_IP6_NEIGHBOR_SOLICIT_HDR_SIZE(nbuf)	\
					(GET_IP6_NEIGHBOR_SOLICIT_HDR_SIZE(nbuf) + IF_HDR_SIZE)

/*
 *  
 */

typedef struct t_neighbor_advert_hdr {
	T_ICMP6_HDR	hdr;
	T_IN6_ADDR	target;
	/* θ˥ץ³ */
	} T_NEIGHBOR_ADVERT_HDR;

/* ICMP6 إåΥǡ */

#define nd_na_flags_reserved		hdr.data.data32

#define NEIGHBOR_ADVERT_HDR_SIZE	(sizeof(T_NEIGHBOR_ADVERT_HDR))
#define IP6_NEIGHBOR_ADVERT_HDR_SIZE	(IP6_HDR_SIZE + NEIGHBOR_ADVERT_HDR_SIZE)
#define IF_IP6_NEIGHBOR_ADVERT_HDR_SIZE	\
					(IF_IP6_HDR_SIZE + NEIGHBOR_ADVERT_HDR_SIZE)
#define IF_IP6_NEIGHBOR_ADVERT_HDR_OFFSET	\
					(IF_IP6_HDR_SIZE)

#define GET_NEIGHBOR_ADVERT_HDR(nbuf,nhoff)	\
					((T_NEIGHBOR_ADVERT_HDR*)((UB*)((nbuf)->buf) + nhoff))
#define GET_NEIGHBOR_ADVERT_SDU(nbuf,nhoff)	\
					((UB*)((nbuf)->buf) + nhoff + NEIGHBOR_ADVERT_HDR_SIZE)

#define GET_IP6_NEIGHBOR_ADVERT_HDR_SIZE(nbuf)		\
					(GET_IP6_HDR_SIZE(GET_IP6_HDR(nbuf)) + NEIGHBOR_ADVERT_HDR_SIZE)
#define GET_IF_IP6_NEIGHBOR_ADVERT_HDR_SIZE(nbuf)	\
					(GET_IP6_NEIGHBOR_ADVERT_HDR_SIZE(nbuf) + IF_HDR_SIZE)

/*
 *  Υե饰nd_na_flags_reserved (hdr.data32) ꤹ롣
 */

#if SIL_ENDIAN == SIL_ENDIAN_BIG

#define ND_NA_FLG_OVERRIDE		0x20000000	/* ٥å	*/
#define ND_NA_FLG_SOLICITED		0x40000000	/* ؤα	*/
#define ND_NA_FLG_ROUTER		0x80000000	/* 롼		*/

#elif SIL_ENDIAN == SIL_ENDIAN_LITTLE

#define ND_NA_FLG_OVERRIDE		0x00000020	/* ٥å	*/
#define ND_NA_FLG_SOLICITED		0x00000040	/* ؤα	*/
#define ND_NA_FLG_ROUTER		0x00000080	/* 롼		*/

#endif	/* #if SIL_ENDIAN == SIL_ENDIAN_BIG */

/*
 *  롼
 */

typedef struct t_router_advert_hdr {
	T_ICMP6_HDR	hdr;
	UW		reachable;		/* [ms] ãǽ	*/
	UW		retransmit;		/* [ms] ֳ	*/
	/* θ˥ץ³ */
	} T_ROUTER_ADVERT_HDR;

/* ICMP6 إåΥǡ */

#define nd_ra_current_hoplimit		hdr.data.data8[0]
#define nd_ra_flags			hdr.data.data8[1]
#define nd_ra_router_lifetime		hdr.data.data16[1]	/* [s] 롼ͭ	*/

#define ROUTER_ADVERT_HDR_SIZE		(sizeof(T_ROUTER_ADVERT_HDR))
#define IP6_ROUTER_ADVERT_HDR_SIZE	(IP6_HDR_SIZE + ROUTER_ADVERT_HDR_SIZE)
#define IF_IP6_ROUTER_ADVERT_HDR_SIZE	(IF_IP6_HDR_SIZE + ROUTER_ADVERT_HDR_SIZE)
#define IF_IP6_ROUTER_ADVERT_HDR_OFFSET	(IF_IP6_HDR_SIZE)

#define GET_ROUTER_ADVERT_HDR(nbuf,nhoff)	\
					((T_ROUTER_ADVERT_HDR*)((UB*)((nbuf)->buf) + nhoff))
#define GET_ROUTER_ADVERT_SDU(nbuf,nhoff)	\
					((UB*)((nbuf)->buf) + nhoff + ROUTER_ADVERT_HDR_SIZE)

#define GET_IP6_ROUTER_ADVERT_HDR_SIZE(nbuf)	\
					(GET_IP6_HDR_SIZE(GET_IP6_HDR(nbuf)) + ROUTER_ADVERT_HDR_SIZE)
#define GET_IF_IP6_ROUTER_ADVERT_HDR_SIZE(nbuf)	\
					(GET_IP6_ROUTER_ADVERT_HDR_SIZE(nbuf) + IF_HDR_SIZE)

/*
 *  롼ΥإåΥե饰
 */

#define ND_RA_FLAG_MANAGED		0x80
#define ND_RA_FLAG_OTHER		0x40
#define ND_RA_FLAG_HA			0x20

/*
 *  롼
 */

typedef struct t_router_solicit_hdr {
	T_ICMP6_HDR	hdr;
	} T_ROUTER_SOLICIT_HDR;

/* ICMP6 إåΥǡ */

#define nd_rs_reserved			hdr.data.data32

#define ROUTER_SOLICIT_HDR_SIZE		(sizeof(T_ROUTER_SOLICIT_HDR))
#define IP6_ROUTER_SOLICIT_HDR_SIZE	(IP6_HDR_SIZE + ROUTER_SOLICIT_HDR_SIZE)
#define IF_IP6_ROUTER_SOLICIT_HDR_SIZE	(IF_IP6_HDR_SIZE + ROUTER_SOLICIT_HDR_SIZE)
#define IF_IP6_ROUTER_SOLICIT_HDR_OFFSET	\
					(IF_IP6_HDR_SIZE)

#define GET_ROUTER_SOLICIT_HDR(nbuf,nhoff)	\
					((T_ROUTER_SOLICIT_HDR*)((UB*)((nbuf)->buf) + nhoff))
#define GET_ROUTER_SOLICIT_SDU(nbuf,nhoff)	\
					((UB*)((nbuf)->buf) + nhoff + ROUTER_SOLICIT_HDR_SIZE)

#define GET_IP6_ROUTER_SOLICIT_HDR_SIZE(nbuf)		\
					(GET_IP6_HDR_SIZE(GET_IP6_HDR(nbuf)) + ROUTER_SOLICIT_HDR_SIZE)
#define GET_IF_IP6_ROUTER_SOLICIT_HDR_SIZE(nbuf)	\
					(GET_IP6_ROUTER_SOLICIT_HDR_SIZE(nbuf) + IF_HDR_SIZE)

/*
 *  õץ
 */

/* õإå */

typedef struct t_neighbor_hdr {
	T_ICMP6_HDR	hdr;
	T_IN6_ADDR	target;
	} T_NEIGHBOR_HDR;

/* õץإå */

typedef struct t_nd_opt_hdr {
	UB	type;			/* ץ󥿥			*/
	UB	len;			/* ץĹñ̤ 8 Х	*/
	} T_ND_OPT_HDR;

#define ND_OPT_HDR_SIZE			(sizeof(T_ND_OPT_HDR))

#define ND_OPT_SOURCE_LINKADDR		1	/* ͥåȥ󥿥եΥɥ쥹	*/
#define ND_OPT_TARGET_LINKADDR		2	/* оݥͥåȥ󥿥եΥɥ쥹	*/
#define ND_OPT_PREFIX_INFORMATION	3	/* ץեå				*/
#define ND_OPT_REDIRECTED_HEADER	4	/* 쥯ȡإå				*/
#define ND_OPT_MTU			5	/* MTU						*/

#define ND_OPT_PREFIX_INFO_COUNT	6	/* ץեåθĿ			*/
#define ND_OPT_OFF_ARRAY_SIZE		7	/* ND ץΥեåȤϿ󥵥*/

#define ND_OPT_OFF_ARRAY_IX(t)		((t)-1)	/* եåΥǥå			*/

/* ץեåץ */

typedef struct t_nd_opt_prefix_info {
	UB		type;		/* õץ󥿥 = 3	*/
	UB		len;		/* ץĹ = 84=32	*/
	UB		prefix_len;	/* ץեåĹ		*/
	UB		flags;		/* ե饰			*/
	UW		valid;		/* [s] ͭ			*/
	UW		preferred;	/* [s] 侩ͭ		*/
	UW		reserved;
	T_IN6_ADDR	prefix;		/* ץեå		*/
	} T_ND_OPT_PREFIX_INFO;

#define ND_OPT_PI_FLAG_ONLINK	0x80	/* 󥯥ץեå	*/
#define ND_OPT_PI_FLAG_AUTO	0x40	/* ơȥ쥹ɥ쥹ư*/

/* MTU ץإå */

typedef struct t_nd_opt_mtu_hdr {
	UB	type;			/* ץ󥿥		*/
	UB	len;			/* ץĹñ̤ 8 Х*/
	UH	reserved;
	UW	mtu;			/* MTU				*/
	} T_ND_OPT_MTU_HDR;

/*
 *  ľ
 */

typedef struct t_nd_redirect_hdr {
	T_ICMP6_HDR	hdr;
	T_IN6_ADDR	target;		/* 롼Υɥ쥹		*/
	T_IN6_ADDR	dst;		/* ľνɥ쥹		*/
	/* θ˥ץ³ */
	} T_ND_REDIRECT_HDR;

#define ND_REDIRECT_HDR_SIZE		(sizeof(T_ND_REDIRECT_HDR))

#ifdef SUPPORT_MIB

/*
 *  SNMP  ١ (MIB)
 */

typedef struct t_icmp6_ifstat {
	UW	ipv6IfIcmpInMsgs;
	UW	ipv6IfIcmpInErrors;
	UW	ipv6IfIcmpInDestUnreachs;
/*	UW	ipv6IfIcmpInAdminProhibs;*/
	UW	ipv6IfIcmpInTimeExcds;
	UW	ipv6IfIcmpInParmProblems;
	UW	ipv6IfIcmpInPktTooBigs;
	UW	ipv6IfIcmpInEchos;
	UW	ipv6IfIcmpInEchoReplies;
/*	UW	ipv6IfIcmpInRouterSolicits;*/
	UW	ipv6IfIcmpInRouterAdvertisements;
	UW	ipv6IfIcmpInNeighborSolicits;
	UW	ipv6IfIcmpInNeighborAdvertisements;
	UW	ipv6IfIcmpInRedirects;
/*	UW	ipv6IfIcmpInGroupMembQueries;*/
/*	UW	ipv6IfIcmpInGroupMembResponses;*/
/*	UW	ipv6IfIcmpInGroupMembReductions;*/
	UW	ipv6IfIcmpOutMsgs;
	UW	ipv6IfIcmpOutErrors;
	UW	ipv6IfIcmpOutDestUnreachs;
/*	UW	ipv6IfIcmpOutAdminProhibs;*/
/*	UW	ipv6IfIcmpOutTimeExcds;*/
	UW	ipv6IfIcmpOutParmProblems;
	UW	ipv6IfIcmpOutPktTooBigs;
	UW	ipv6IfIcmpOutEchos;
	UW	ipv6IfIcmpOutEchoReplies;
	UW	ipv6IfIcmpOutRouterSolicits;
/*	UW	ipv6IfIcmpOutRouterAdvertisements;*/
	UW	ipv6IfIcmpOutNeighborSolicits;
	UW	ipv6IfIcmpOutNeighborAdvertisements;
/*	UW	ipv6IfIcmpOutRedirects;*/
/*	UW	ipv6IfIcmpOutGroupMembQueries;*/
/*	UW	ipv6IfIcmpOutGroupMembResponses;*/
/*	UW	ipv6IfIcmpOutGroupMembReductions;*/
} T_ICMP6_IFSTAT;

extern T_ICMP6_IFSTAT icmp6_ifstat;

#endif	/* of #ifdef SUPPORT_MIB */

/*
 *  ؿ
 */

extern UINT icmp6_input (T_NET_BUF **inputp, UINT *offp, UINT *nextp);
extern void icmp6_error (T_NET_BUF *input, UB type, UB code, UW param);

#ifdef ICMP_CFG_CALLBACK_ECHO_REPLY

extern void icmp6_echo_reply (T_NET_BUF *input, UINT ihoff);

#endif	/* of #ifdef ICMP_CFG_CALLBACK_ECHO_REPLY */

#endif	/* of #ifdef SUPPORT_INET6 */

#endif	/* of #ifndef _IP_ICMP6_H_ */
