/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2007 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: tcp_input.c,v 1.4 2007/11/09 00:43:30 abe Exp abe $
 */

/*
 * Copyright (c) 1982, 1986, 1988, 1990, 1993, 1994, 1995
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)tcp_input.c	8.12 (Berkeley) 5/24/95
 * $FreeBSD: src/sys/netinet/tcp_input.c,v 1.82.2.3 1999/10/14 11:49:38 des Exp $
 */

#include <string.h>

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/if.h>
#include <net/if_ppp.h>
#include <net/if_loop.h>
#include <net/ethernet.h>
#include <net/net.h>
#include <net/net_var.h>
#include <net/net_buf.h>
#include <net/net_timer.h>
#include <net/net_count.h>

#include <netinet/in.h>
#include <netinet/in_var.h>
#include <netinet6/in6.h>
#include <netinet6/in6_var.h>
#include <netinet6/nd6.h>
#include <netinet/in_itron.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>
#include <netinet/ip6.h>
#include <netinet6/ip6_var.h>
#include <netinet/ip_icmp.h>
#include <netinet/tcp.h>
#include <netinet/tcp_timer.h>
#include <netinet/tcp_var.h>
#include <netinet/tcp_fsm.h>
#include <netinet/tcp_seq.h>

#ifdef SUPPORT_TCP

/*
 *  
 *
 *      RET_OK		
 *	RET_DROP	顼Ȥ˴롣
 *	RET_RST_DROP	顼RST Ȥ˴롣
 */

#define RET_OK		(0)
#define RET_NEED_OUTPUT	(1)
#define RET_RETURN	(2)
#define RET_DROP	(-1)
#define RET_RST_DROP	(-2)

/*
 *  ؿ
 */

static void close_connection	(T_TCP_CEP *cep, BOOL *needoutput);
static void set_rexmt_timer	(T_TCP_CEP *cep,  T_TCP_TIME rtt);
static UB reassemble		(T_NET_BUF *input, T_TCP_CEP *cep, UINT thoff, UB flags);
static ER drop_after_ack	(T_NET_BUF *input, T_TCP_CEP *cep, UINT thoff);
static ER listening		(T_NET_BUF *input, T_TCP_CEP *cep, UINT thoff, T_TCP_SEQ iss);
static ER proc_ack1		(T_NET_BUF *input, T_TCP_CEP *cep, UINT thoff, BOOL *needoutput);
static ER proc_ack2		(T_NET_BUF *input, T_TCP_CEP *cep, UINT thoff, BOOL *needoutput);
static ER syn_sent		(T_TCP_HDR *tcph,  T_TCP_CEP *cep);
static void trim_length		(T_TCP_HDR *tcph,  T_TCP_CEP *cep);
static void parse_option	(T_TCP_HDR *tcph,  T_TCP_CEP *cep);
static BOOL update_wnd		(T_TCP_HDR *tcph,  T_TCP_CEP *cep);
static void proc_urg		(T_TCP_HDR *tcph,  T_TCP_CEP *cep);

#if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0

/*
 *   Time Wait  CEP ʬΥǽ
 */

/*
 *  ؿ
 */

static T_TCP_TWCEP*tcp_find_twcep (T_IN_ADDR *dstaddr, UH dstport,
                                      T_IN_ADDR *peeraddr, UH peerport);

/*
 *  ѿ
 */

T_TCP_TWCEP tcp_twcep[NUM_TCP_TW_CEP_ENTRY];

/*
 *  tcp_find_twcep -- ݡֹ椫 Time Wait  TCP ̿ü롣
 *
 *    : dstaddr ϡͥåȥХȥ
 */

static T_TCP_TWCEP*
tcp_find_twcep (T_IN_ADDR *dstaddr, UH dstport, T_IN_ADDR *peeraddr, UH peerport)
{
	T_TCP_TWCEP*	twcep;
	
	/*
	 *  ֤ TIME WAIT ǡ
	 *  IP ɥ쥹ȥݡֹ椬פ̿üõ롣
	 */
	for (twcep = &tcp_twcep[NUM_TCP_TW_CEP_ENTRY]; twcep -- != tcp_twcep; ) {
		if (twcep->fsm_state == TCP_FSM_TIME_WAIT                   &&
		    IN_IS_DSTADDR_ACCEPT (&twcep->myaddr.ipaddr,  dstaddr)  &&
		    IN_ARE_NET_ADDR_EQUAL(&twcep->dstaddr.ipaddr, peeraddr) &&
		    dstport  == twcep->myaddr.portno                        &&
		    peerport == twcep->dstaddr.portno)
			return twcep;
		}

	return NULL;
	}

/*
 *  ɬפʾ Time Wait  TCP ̿ü˰ܤơ
 *  ɸ TCP ̿ü롣
 */

void
tcp_move_twcep (T_TCP_CEP *cep)
{
	T_TCP_TWCEP*	twcep;

	/*  Time Wait  TCP ̿üõ롣*/
	for (twcep = &tcp_twcep[NUM_TCP_TW_CEP_ENTRY]; twcep -- != tcp_twcep; ) {
		if (twcep->fsm_state != TCP_FSM_TIME_WAIT) {

			/*
			 *  ̿üå
			 *  ɬפʾ Time Wait  TCP ̿ü˰ܤ
			 */
			syscall(wai_sem(cep->semid_lock));
			twcep->rbufsz		= cep->rbufsz;
			twcep->dstaddr		= cep->dstaddr;
			twcep->myaddr		= cep->myaddr;
			twcep->snd_una		= cep->snd_una;
			twcep->rcv_nxt		= cep->rcv_nxt;
			twcep->rwbuf_count	= cep->rwbuf_count;
			twcep->fsm_state	= cep->fsm_state;
			twcep->timer_2msl	= cep->timer[TCP_TIM_2MSL];

			/* ̿üå롣*/
			syscall(sig_sem(cep->semid_lock));

			/* ɸ TCP ̿ü롣*/
			tcp_close(cep);

			break;
			}
		}
	}

#endif	/* of #if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0 */

/*
 *  parse_option -- TCP إåΥץϤ롣
 */

static void
parse_option (T_TCP_HDR *tcph, T_TCP_CEP *cep)
{
	UB	*opt, type;
	UINT	len, ol, ssize;

	opt = (UB*)tcph + TCP_HDR_SIZE;
	len = (UINT)(TCP_HDR_LEN(tcph->doff) - TCP_HDR_SIZE);
	while (len > 0 && (type = *opt) != TCP_OPT_EOL) {
		if (type == TCP_OPT_NOP)
			ol = 1u;
		else {
			if (len < 2)
				break;
			ol = *(opt + 1);
			if (ol < 2 || ol > len)
				break;
			}
		switch (type) {
		case TCP_OPT_NOP:
			break;
		case TCP_OPT_MAXSEG:
			if ((tcph->flags & TCP_FLG_SYN)) {
				ssize = ntohs(*(UH*)(opt + 2));
				if (ssize > MAX_TCP_SND_SEG)
					cep->maxseg = MAX_TCP_SND_SEG;
				else
					cep->maxseg = ssize;
				}
			break;

		case TCP_OPT_WINDOW:
		case TCP_OPT_SACK_PERM:
		case TCP_OPT_TIMESTAMP:
		case TCP_OPT_CC:
		case TCP_OPT_CCNEW:
		case TCP_OPT_CCECHO:
			syslog(LOG_INFO, "[TCP] unsup opt: %d.", type);
			break;

		default:
			syslog(LOG_NOTICE, "[TCP] unexp opt: %d.", type);
			break;
			}
		opt += ol;
		len -= ol;
		}
	}

/*
 *  set_rexmt_timer -- ֤ޤ򹹿롣
 */

static void
set_rexmt_timer (T_TCP_CEP *cep, T_TCP_TIME rtt)
{
	T_TCP_TIME delta;

	NET_COUNT_TCP(net_count_tcp[NC_TCP_RTT_UPDATES], 1);
	if (cep->srtt != 0) {
		/*
		 *  srtt: ʿ경줿 RTT
		 *
		 *  ¬줿 RTT (rtt) ȸߤʿ경줿 RTT (srtt) κ (delta) 롣
		 *
		 *  delta  2 ӥåȺե ( 4 ) ͤݻ롣
		 *  srtt   5 ӥåȺե (32 ) ͤݻƤ롣
		 *
		 *    delta = rtt / 8 - srtt / 8
		 *
		 *   srtt 
		 *
		 *    srtt = rtt / 8 + srtt * 7 / 8
		 *         = srtt + (rtt / 8 - srtt / 8)
		 *
		 *  Ƿ׻롣
		 *  Τᡢrtt  2 ӥåȺեȤsrtt  (5 - 2) ӥåȱեȤ delta 롣
		 */
		delta = ((rtt - 1) << TCP_DELTA_SHIFT) - (cep->srtt >> (TCP_SRTT_SHIFT - TCP_DELTA_SHIFT));
		cep->srtt += delta;
		if (cep->srtt <= 0)
			cep->srtt = 1;

		/*
		 *  delta  | delta | 롣
		 */
		if (delta < 0)
			delta = - delta;

		/*
		 *  rttvar: ʿ경줿ʬ
		 *
		 *  rttvar  4 ӥåȺե (16 ) ͤݻƤ롣
		 *
		 *    delta = |delta| / 4 - rttvar / 4
		 *
		 *   rttvar 
		 *
		 *    rttvar = |delta|/ 4 + rttvar * 3 /4
		 *           = rttvar + (|delta| / 4 - rttvar / 4)
		 *
		 *  Ƿ׻롣
		 */
		delta -= cep->rttvar >> (TCP_RTTVAR_SHIFT - TCP_DELTA_SHIFT);
		cep->rttvar += delta;
		if (cep->rttvar <= 0)
			cep->rttvar = 1;
		}
	else {
		/*
		 *  ޤ srtt ꤬ԤƤʤȤϡ¬줿 RTT Ѥ롣
		 *  ʿ경줿 RTT (srtt) ˤϡRTT  5 ӥåȺե (32) ͡
		 *  ʿ경줿ʬ (rttvar) ˤϡRTT  1/2  4 ӥåȺե (16) ͡
		 */
		cep->srtt   = rtt <<  TCP_SRTT_SHIFT;
		cep->rttvar = rtt << (TCP_RTTVAR_SHIFT - 1);
		}

	/*
	 *  rtt ¬λꥻåȤ롣
	 */
	cep->rtt = cep->rxtshift = 0;

	/*
	 *  RTT ˵Ǿ  rtt + 2 礭ͤॢȤκǾͤˤ롣
	 */
	if (rtt + 2 < TCP_TVAL_MIN)
		cep->rxtcur = tcp_range_set(tcp_rexmt_val(cep),
		                            (T_TCP_TIME)TCP_TVAL_MIN,
		                            (T_TCP_TIME)TCP_TVAL_MAX_REXMT);
	else
		cep->rxtcur = tcp_range_set(tcp_rexmt_val(cep),
		                            (T_TCP_TIME)(rtt + 2),
		                            (T_TCP_TIME)TCP_TVAL_MAX_REXMT);
	}

/*
 *  reassemble -- Ȥƹ롣̤˼Ȥν
 */

static UB
reassemble (T_NET_BUF *input, T_TCP_CEP *cep, UINT thoff, UB flags)
{
	T_TCP_Q_HDR 	*qhdr;
	T_TCP_HDR	*tcph;

	tcph = GET_TCP_HDR(input, thoff);
	if (tcph->sum > cep->rbufsz - cep->rwbuf_count) {
		/*
		 *  ɥХåե˶ʤȤ˴롣
		 */
		NET_COUNT_TCP(net_count_tcp[NC_TCP_RECV_DROP_SEGS], 1);
		syscall(rel_net_buf(input));
		cep->flags |= TCP_CEP_FLG_ACK_NOW;
		flags &= ~TCP_FLG_FIN;
		}
	else if (tcph->seq == cep->rcv_nxt &&
	         cep->reassq == NULL &&
	         cep->fsm_state == TCP_FSM_ESTABLISHED) {
		/*
		 *  ̤˥Ȥν
		 *  Ȥ¤ؤפʤΤ
		 *  Τޤ޼ɥХåե˽񤭹ࡣ
		 */

#ifdef TCP_CFG_DELAY_ACK

		cep->flags |= TCP_CEP_FLG_DEL_ACK;

#else/* of #ifdef TCP_CFG_DELAY_ACK */

		cep->flags |= TCP_CEP_FLG_ACK_NOW;

#endif/* of #ifdef TCP_CFG_DELAY_ACK */

		qhdr = GET_TCP_Q_HDR(input, thoff);

		/*  TCP إåΰ֤¸롣*/
		GET_TCP_IP_Q_HDR(input)->thoff = thoff;

		/* SDU ΥեåȡʸϥɥˤꥻåȤ롣*/
		qhdr->soff = 0;

		/* ǡɥХåե˽񤭹ࡣ*/
		TCP_WRITE_RWBUF(cep, input, thoff);
		}
	else {
		flags = tcp_write_raque(input, cep, thoff, flags);
		cep->flags |= TCP_CEP_FLG_ACK_NOW;
		}
	return flags;
	}

/*
 *  listening -- ưץ󤷤ơ֤ LISTEN ν
 *
 *    :
 *      RET_OK		
 *	RET_DROP	顼Ȥ˴롣
 *	RET_RST_DROP	顼RST Ȥ˴롣
 */

static ER
listening (T_NET_BUF *input, T_TCP_CEP *cep, UINT thoff, T_TCP_SEQ iss)
{
	T_IP_HDR	*iph;
	T_TCP_HDR	*tcph;

	iph  = GET_IP_HDR(input);
	tcph = GET_TCP_HDR(input, thoff);

	/* 
	 *  ե饰 RST åȤƤ˴롣
	 */
	if (tcph->flags & TCP_FLG_RST)
		return RET_DROP;

	/*  
	 *  ե饰 ACK åȤƤ줤С
	 *  ꥻåȤä˴롣
	 */
	if (tcph->flags & TCP_FLG_ACK)
		return RET_RST_DROP;

	/* 
	 *  ե饰 SYN åȤƤʤФ˴롣
	 */
	if ((tcph->flags & TCP_FLG_SYN) == 0)
		return RET_DROP;

#ifdef SUPPORT_INET4

#ifdef SUPPORT_LOOP

	/*
	 *  ΤȤ˴롣
	 *    ݡֹ椬Ʊǡ IP ɥ쥹 Ʊ졣
	 *      롼ץХå (127.0.0.1) ʤɤ
	 *    ޥ㥹ȥɥ쥹
	 */

	if (tcph->dport == tcph->sport &&
	    (iph->dst == iph->src && ntohl(iph->src) != IPV4_ADDR_LOOPBACK))
		return RET_DROP;

#else	/* of #ifdef SUPPORT_LOOP */

	/*
	 *  ΤȤ˴롣
	 *    ݡֹ椬Ʊǡ IP ɥ쥹 Ʊ졣
	 *    ޥ㥹ȥɥ쥹
	 */

	if (tcph->dport == tcph->sport && iph->dst == iph->src)
		return RET_DROP;

#endif	/* of #ifdef SUPPORT_LOOP */

#else	/* of #ifdef SUPPORT_INET4 */

	/*
	 *  ΤȤ˴롣
	 *    ݡֹ椬Ʊǡ IP ɥ쥹 Ʊ졣
	 *    ޥ㥹ȥɥ쥹
	 */

	if (tcph->dport == tcph->sport && IN_ARE_ADDR_EQUAL(&iph->dst, &iph->src))
		return RET_DROP;

#endif	/* of #ifdef SUPPORT_INET4 */

	if (IN_IS_NET_ADDR_MULTICAST(&iph->dst))
		return RET_DROP;

	/* Υɥ쥹Ͽ롣*/
	IN_COPY_TO_HOST(&cep->dstaddr.ipaddr, &iph->src);
	cep->dstaddr.portno = tcph->sport;

	/* ץ롣*/
	parse_option(tcph, cep);

	/* ֹ롣*/
	if (tcp_iss == 0)
		tcp_init_iss();

	/* ʬΥֹνͤϿ롣*/
	if (iss != 0)
		cep->iss = iss;
	else
		cep->iss = tcp_iss;

	tcp_iss += TCP_ISS_INCR() / 4;

	/* ΥֹνͤϿ롣*/
	cep->irs = tcph->seq;

	/* ֹ롣*/
	init_send_seq(cep);
	init_receive_seq(cep);

	/* ɥꤹ롣*/
	cep->snd_wnd = tcph->win;

	/* ǽ */
	cep->flags    |= TCP_CEP_FLG_ACK_NOW;
	cep->fsm_state = TCP_FSM_SYN_RECVD;
	cep->timer[TCP_TIM_KEEP] = TCP_TVAL_KEEP_IDLE;

	return RET_OK;
	}

/*
 *  syn_sent -- ǽưץ󤷤ơ֤ SYN Ѥν
 *
 *    :
 *      RET_OK		
 *	RET_DROP	顼Ȥ˴롣
 *	RET_RST_DROP	顼RST Ȥ˴롣
 */

static ER
syn_sent (T_TCP_HDR *tcph, T_TCP_CEP *cep)
{
	ER error = RET_OK;

	/*
	 *  ꤫ǧƤ⡢
	 *
	 *    ACK <= iss &&  SEQ (snd_max) < ACK
	 *
	 *  ʤ顢ꥻåȤäƥȤ˴롣
	 */
	if ((tcph->flags & TCP_FLG_ACK) &&
	    (SEQ_LE(tcph->ack, cep->iss) || SEQ_GT(tcph->ack, cep->snd_max)))
		return RET_RST_DROP;

	/*
	 *  RST/ACK ե饰αСݡȤƤʤ
	 *  Ȥ̣Ƥ롣
	 */
	if (tcph->flags & TCP_FLG_RST) {
		if (tcph->flags & TCP_FLG_ACK) {
			cep->net_error = EV_CNNRF;
			cep = tcp_drop(cep, E_CLS);
			}
		return RET_DROP;
		}

	/*
	 *  SYN ե饰ʤХȤ˴롣
	 */
	if ((tcph->flags & TCP_FLG_SYN) == 0)
		return RET_DROP;

	cep->snd_wnd = tcph->win;	/* snd_wnd: μǽɥ	*/
	cep->irs     = tcph->seq;	/* irs:     Υֹν	*/
	init_receive_seq(cep);		/* ֹ롣		*/

	if (tcph->flags & TCP_FLG_ACK) {
		/*
		 *  ACK ե饰Ȥν
		 *
		 *  ԤƤ SEQ (rcv_adv) 
		 *  ǽʥɥ (rcv_wnd) ʬʤ롣
		 */
		cep->rcv_adv += cep->rcv_wnd;	/* rcv_adv: ԤƤ SEQ	*/
						/* rcv_wnd: ǽʥɥ		*/

		/* ̤ǧκǾ SEQ (snd_una)  SYN ʬ (1 ƥå) ʤ롣*/
		cep->snd_una ++;

#ifdef TCP_CFG_DELAY_ACK

		if (tcph->sum != 0)		/* tcph->sum  SDU Ĺ */
			cep->flags |= TCP_CEP_FLG_DEL_ACK;
		else
			cep->flags |= TCP_CEP_FLG_ACK_NOW;

#else/* of #ifdef TCP_CFG_DELAY_ACK */

		cep->flags |= TCP_CEP_FLG_ACK_NOW;

#endif/* of #ifdef TCP_CFG_DELAY_ACK */

		if (cep->flags & TCP_CEP_FLG_NEED_FIN) {
			/*
			 *  CEP  FIN ׵ᤵƤС
			 *  ǽ򳫻Ϥ
			 *  CEP ξ֤ FIN Wait 1 ˤ롣
			 */
			cep->fsm_state = TCP_FSM_FIN_WAIT_1;
			cep->flags  &= ~TCP_CEP_FLG_NEED_FIN;
			tcph->flags &= ~TCP_FLG_SYN;
			}
		else {
			/*
			 *  ꤫ ACK 줿Τǡ
			 *  CEP ξ֤ ͥߴλ֤ˤ롣
			 */
			cep->timer[TCP_TIM_KEEP] = TCP_TVAL_KEEP_IDLE;
			cep->fsm_state  = TCP_FSM_ESTABLISHED;
			NET_COUNT_MIB(tcp_stats.tcpActiveOpens, 1);
			syscall(set_flg(cep->est_flgid, CEP_EVT_ESTABLISHED));

#ifdef TCP_CFG_NON_BLOCKING

			if (cep->snd_nblk_tfn == TFN_TCP_CON_CEP) {

				/* Υɥ쥹򥳥ԡ롣*/
				*cep->p_dstaddr = cep->dstaddr;

				if (IS_PTR_DEFINED(cep->callback)) {
					NET_COUNT_TCP(net_count_tcp[NC_TCP_CONNECTS], 1);
					(*cep->callback)(GET_TCP_CEPID(cep), cep->snd_nblk_tfn, (VP)E_OK);
					}
				else {
					syslog(LOG_WARNING, "[TCP] no call back, CEP: %d.", GET_TCP_CEPID(cep));
					error = RET_RST_DROP;
					}
				cep->p_dstaddr = NULL;
				cep->snd_tskid = TA_NULL;
				cep->snd_tfn   = cep->snd_nblk_tfn = TFN_TCP_UNDEF;
				}
			else

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

				NET_COUNT_TCP(net_count_tcp[NC_TCP_CONNECTS], 1);
			}
		}
	else {
		/* ACK ե饰ʤȤϡACK äơCEP ξ֤ SYN Ѥߤˤ롣*/
		cep->flags |= TCP_CEP_FLG_ACK_NOW;
		cep->timer[TCP_TIM_REXMT] = 0;
		cep->fsm_state  = TCP_FSM_SYN_RECVD;
		}

	return error;
	}

/*
 *  trim_length --  SDU ĹĴ롣
 */

static void
trim_length (T_TCP_HDR *tcph, T_TCP_CEP *cep)
{
	tcph->seq ++;
	if (tcph->sum > cep->rcv_wnd) {		/* : tcph->sum  SDU Ĺ */
		/*
		 *  SDU Ĺɥ礭Ȥϡɥʹߤ
		 *  ˴FIN ˱ʤȤǡ˴ǡ롣
		 */
		tcph->sum    = (UH)cep->rcv_wnd;
		tcph->flags &= ~TCP_FLG_FIN;
		}
	cep->snd_wl1 = tcph->seq - 1;		/* cep->snd_wl1: ɹ SEQ ֹ	*/

#ifdef TCP_CFG_EXTENTIONS
	cep->rcv_up  = tcph->seq;		/* cep->rcv_up : ۵ޥݥ	*/
#endif
	}

/*
 *  proc_ack2 -- ACK ν (2)
 *
 *    
 *
 *      RET_OK		
 *      RET_RETURN	꥿󤹤롣
 *	RET_DROP	顼Ȥ˴롣
 *	RET_RST_DROP	顼RST Ȥ˴롣
 */

static ER
proc_ack2 (T_NET_BUF *input, T_TCP_CEP *cep, UINT thoff, BOOL *needoutput)
{
	T_TCP_HDR	*tcph;
	ER		ret = RET_OK;
	UW		acked;
	BOOL		ourfinisacked = FALSE;

	tcph = GET_TCP_HDR(input, thoff);

	/*
	 *  ˼ǧ줿 ACK 顢ޤǧƤʤ
	 *  Ǿ SEQ (snd_una) ȡɥХåե
	 *  Ƥ褤ƥåȿ (acked) ˤʤ롣
	 */
	acked = tcph->ack - cep->snd_una;
	NET_COUNT_TCP(net_count_tcp[NC_TCP_RECV_ACKS], 1);

	/*
	 *  ַ¬ (rtt) ꤵƤơ¬ SEQ 
	 *   ACK 顢ޥХåդ򥭥󥻥뤷
	 *  ޤꤹ롣
	 */
	if (cep->rtt && SEQ_GT(tcph->ack, cep->rtseq)) {
		set_rexmt_timer(cep, cep->rtt);
		}

	/*
	 *  Ƥ̤ǧǡ ACK 줿顢ޤߤ
	 *  Ƴ򵭲 (˽Ϥ³)
	 *  ⤷ACK ٤¿Υǡʤ顢ޤ
	 *  ߤκॢȤꤹ롣
	 */
	if (tcph->ack == cep->snd_max) {	/* cep->snd_max:  SEQ */
		cep->timer[TCP_TIM_REXMT] = 0;
		*needoutput = TRUE;
		}
	else if (cep->timer[TCP_TIM_PERSIST] == 0) {
	 	cep->timer[TCP_TIM_REXMT] = cep->rxtcur;	/* cep->rxtcur: ߤκॢ */
		}

	/* ꤬ǧǡȤν */
	if (acked) {
		UW cw   = cep->snd_cwnd;	/* cep->snd_cwnd: ԥɥ	*/
		UW incr = cep->maxseg;		/* cep->maxseg:   祻ȥ	*/

		/*
		 *  ꤬ǧǡäȤϡ
		 *  ԥɥ礭롣
		 *  ԥɥ (snd_cwnd) 
		 *  ԥɥΤ (snd_ssthresh) 礭Ȥ
		 *  ԲԤ
		 *
		 *    snd_cwnd = snd_cwnd + maxseg * maxseg / snd_cwnd;
		 *
		 *  ȤϡԤ
		 *
		 *    snd_cwnd = snd_cwnd + maxseg
		 *
		 */
		if (cw > cep->snd_ssthresh)
			/* Բ */
			incr = incr * incr / cw;

		if (cw + incr < MAX_TCP_WIN_SIZE)
			cep->snd_cwnd = (UH)(cw + incr);
		else
			cep->snd_cwnd = MAX_TCP_WIN_SIZE;

		/*
		 *  ɥХåե顢꤬ǧǡ (acked) Υǡ롣
		 */
		if (acked > cep->swbuf_count) {
			cep->snd_wnd -= cep->swbuf_count;
			TCP_DROP_SWBUF(cep, (UINT)cep->swbuf_count);
			ourfinisacked = TRUE;
			}
		else {
			cep->snd_wnd -= (UH)acked;
			TCP_DROP_SWBUF(cep, (UINT)acked);
			ourfinisacked = FALSE;
			}

		/* ɥХåե˶ǤȤΤ餻롣*/
		syscall(set_flg(cep->snd_flgid, CEP_EVT_SWBUF_READY));

		/*
		 *  ãǧƤʤǾ SEQ (snd_una) 
		 *  ãǧ줿 ACK ޤǿʤᡢ
		 *  ǡ SEQ (snd_nxt) ⡢
		 *  ãǧƤʤǾ SEQ (snd_una)
		 *  ޤǿʤ롣
		 */
		cep->snd_una += acked;
		if (SEQ_LT(cep->snd_nxt, cep->snd_una))
			cep->snd_nxt = cep->snd_una;

		/*
		 *  ֤ˤʬ
		 */
		switch (cep->fsm_state) {
		case TCP_FSM_FIN_WAIT_1:	/* APP λFIN ѤߡACK Ԥ */
			if (ourfinisacked) {
				cep->fsm_state = TCP_FSM_FIN_WAIT_2;
				cep->timer[TCP_TIM_2MSL] = TCP_TVAL_KEEP_COUNT * TCP_TVAL_KEEP_INTERVAL;
				}
			break;
		case TCP_FSM_CLOSING:		/* ƱFIN 򴹺ѤߡACK Ԥ */
			if (ourfinisacked) {
				/*
				 *   FIN ǧƤо֤ѹ
				 *  ٤ƤΥޤꥻåȤ塢2MSL ޤꤹ롣
				 */
				cep->fsm_state = TCP_FSM_TIME_WAIT;
				tcp_cancel_timers(cep);
				cep->timer[TCP_TIM_2MSL] = 2 * TCP_TVAL_MSL;
				}
			break;
		case TCP_FSM_LAST_ACK:		/* APP λACK Ԥ */
			if (ourfinisacked) {
				/*
				 *   FIN ǧƤСcep 򥯥
				 *  Ȥ˴롣
				 */
				cep = tcp_close(cep);
				ret = RET_DROP;
				}
			break;
		case TCP_FSM_TIME_WAIT:		/* ꤫ FIN ѤߡԤ */
			/*
			 *  ꤫ FIN 줿⤦2MSL ޤꤷ
			 *  ACK 塢Ȥ˴롣
			 */
			cep->timer[TCP_TIM_2MSL] = 2 * TCP_TVAL_MSL;
			return drop_after_ack(input, cep, thoff);
			}
		}

	return ret;
	}

/*
 *  proc_ack1 -- ACK ν (1)
 *
 *    :
 *      RET_OK		
 *      RET_RETURN	꥿󤹤롣
 *	RET_DROP	顼Ȥ˴롣
 *	RET_RST_DROP	顼RST Ȥ˴롣
 *
 */

static ER
proc_ack1 (T_NET_BUF *input, T_TCP_CEP *cep, UINT thoff, BOOL *needoutput)
{
	T_TCP_HDR *tcph = GET_TCP_HDR(input, thoff);

	switch (cep->fsm_state) {
	case TCP_FSM_SYN_RECVD:		/* SYN SYN Ѥ	*/

		/* ֤ѹ롣*/
		if (cep->flags & TCP_CEP_FLG_NEED_FIN) {
			cep->fsm_state  = TCP_FSM_FIN_WAIT_1;
			cep->flags &= ~TCP_CEP_FLG_NEED_FIN;
			}
		else {
			cep->timer[TCP_TIM_KEEP] = TCP_TVAL_KEEP_IDLE;
			cep->fsm_state  = TCP_FSM_ESTABLISHED;

			/* TCP ̿üTCP ո롣*/
			cep->rep = NULL;

			NET_COUNT_MIB(tcp_stats.tcpPassiveOpens, 1);
			syscall(set_flg(cep->est_flgid, CEP_EVT_ESTABLISHED));

#ifdef TCP_CFG_NON_BLOCKING

			if (cep->rcv_nblk_tfn == TFN_TCP_ACP_CEP) {

				/* Υɥ쥹򥳥ԡ롣*/
				*cep->p_dstaddr = cep->dstaddr;

				if (IS_PTR_DEFINED(cep->callback)) {
					NET_COUNT_TCP(net_count_tcp[NC_TCP_ACCEPTS], 1);
					(*cep->callback)(GET_TCP_CEPID(cep), cep->rcv_nblk_tfn, (VP)E_OK);
					cep->p_dstaddr = NULL;
					cep->rcv_tskid = TA_NULL;
					cep->rcv_tfn   = cep->rcv_nblk_tfn = TFN_TCP_UNDEF;
					}
				else {
					syslog(LOG_WARNING, "[TCP] no call back, CEP: %d.", GET_TCP_CEPID(cep));
					cep->p_dstaddr = NULL;
					cep->rcv_tskid = TA_NULL;
					cep->rcv_tfn   = cep->rcv_nblk_tfn = TFN_TCP_UNDEF;
					return RET_RST_DROP;
					}
				}
			else

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

				NET_COUNT_TCP(net_count_tcp[NC_TCP_ACCEPTS], 1);
			}

		/*
		 *  SDU ʤ FIN ĤƤʤСtcp_move_ra2rw() ƽФ
		 */
		if (tcph->sum == 0 && (tcph->flags & TCP_FLG_FIN) == 0)		/* tcph->sum  SDU Ĺ */
			tcph->flags = tcp_move_ra2rw(cep, tcph->flags);
		
		cep->snd_wl1 = tcph->seq - 1;	/* snd_wl1: ɹ SEQ */

		/* break; 롣*/
	
	case TCP_FSM_ESTABLISHED:	/* ͥߴλ		*/
	case TCP_FSM_FIN_WAIT_1:	/* λơFIN Ѥ		*/
	case TCP_FSM_FIN_WAIT_2:	/* λFIN ãǧFINԤ*/
	case TCP_FSM_CLOSE_WAIT:	/* FIN Ԥ		*/
	case TCP_FSM_CLOSING:		/* λFIN 򴹺ѤߡACK Ԥ	*/
	case TCP_FSM_LAST_ACK:		/* FIN λACK Ԥ	*/
	case TCP_FSM_TIME_WAIT:		/* λԤ		*/

		if (SEQ_LE(tcph->ack, cep->snd_una)) {

			/*
			 *  ǧ ACK  ̤ǧκǾ SEQ (snd_una) ƱΤȤν
			 *  Ĥޤꡢ¿Ť ACK Ȥ̣Ƥ롣
			 */

			if (tcph->sum == 0 && tcph->win == cep->snd_wnd) {	/* tcph->sum  SDU Ĺ */

				/*
				 *  SDU ʤΥɥѹƤʤС
				 *  ǤȤǡACK (tcph->ack) 
				 *  Ʊ SEQ Ϥޤ륻ȤǾüǽ롣
				 *  ξϡ®žȹ®ꥫХԤ
				 */
				NET_COUNT_TCP(net_count_tcp[NC_TCP_RECV_DUP_ACKS], 1);

				if (cep->timer[TCP_TIM_REXMT] == 0 || tcph->ack != cep->snd_una) {

					/*
					 *  ޤåȤƤʤȤ
					 *  ޤϡACK (tcph->ack) ̤ǧκǾ SEQ
					 *  פʤȤϡ¿ ACK  0 ˤ롣
					 */
					cep->dupacks = 0;
					}

				else if (++ cep->dupacks == MAX_TCP_REXMT_THRESH) {

					/*
					 *  ¿ ACK  (ɸ 3) ˤʤä
					 *  ®ž򳫻Ϥ롣
					 */
					UINT		win;

					/*
					 *  ԥɥ(snd_cwnd)Τͤꤹ롣
					 *
					 *    μǽɥ (snd_wnd) 
					 *    ԥɥ (snd_cwnd)  1/2
					 *    2 * maxseg ʾ塣
					 *
					 */
					if (cep->snd_wnd < cep->snd_cwnd)
						win = cep->snd_wnd / 2 / cep->maxseg;
					else
						win = cep->snd_cwnd / 2 / cep->maxseg;
					if (win < 2)
						win = 2;
					cep->snd_ssthresh = win * cep->maxseg;

					/* ޤȱ֤ꥻåȤ롣*/
					cep->timer[TCP_TIM_REXMT] = 0;
					cep->rtt = 0;

					/* üȤ롣*/
					cep->snd_old_nxt = cep->snd_nxt;
					cep->snd_nxt     = tcph->ack;
					cep->snd_cwnd    = cep->maxseg;

					/*
					 *  snd_nxt 򸵤᤹褦ꤷ
					 *  ؼ롣
					 */
					cep->flags |=  TCP_CEP_FLG_POST_OUTPUT |
					               TCP_CEP_FLG_FORCE       |
					               TCP_CEP_FLG_FORCE_CLEAR |
					               TCP_CEP_FLG_RESTORE_NEXT_OUTPUT;
					sig_sem(SEM_TCP_POST_OUTPUT);

					/* ԥɥ򹹿롣*/
					cep->snd_cwnd = (UH)(cep->snd_ssthresh
					                   + cep->maxseg * cep->dupacks);
					
					return RET_DROP;
					}

				else if (cep->dupacks > MAX_TCP_REXMT_THRESH) {

					/*
					 *  ¿ ACK  (ɸ 3) Ķ
					 *  ԥɥäʤ롣
					 */
					cep->snd_cwnd += cep->maxseg;

					/* ؼ롣*/
					cep->flags |=  TCP_CEP_FLG_POST_OUTPUT;
					sig_sem(SEM_TCP_POST_OUTPUT);

					return RET_DROP;
					}
				} 
			else
				cep->dupacks = 0;
			break;
			}

		/*
		 *  ǧ ACK  ̤ǧκǾ SEQ (snd_una) ʹߤΤȤν
		 */
		if (cep->dupacks >= MAX_TCP_REXMT_THRESH && cep->snd_cwnd > cep->snd_ssthresh)
		 	/*
			 *  ®žԤäƤȤϡԥɥ򤷤ͤޤ᤹
			 */
			cep->snd_cwnd = (UH)cep->snd_ssthresh;
	
		cep->dupacks = 0;

		if (SEQ_GT(tcph->ack, cep->snd_max))
			/*
			 *   ACK  SEQ ĶƤȤν
			 */
			return drop_after_ack(input, cep, thoff);

		if (cep->flags & TCP_CEP_FLG_NEED_SYN) {
			/*
			 *  SYN ׵äơ̤ǧκǾ SEQ ʤ롣
			 */
			cep->flags &= ~TCP_CEP_FLG_NEED_SYN;
			cep->snd_una ++;
			}
		
		return proc_ack2(input, cep, thoff, needoutput);
		break;
		}
	return RET_OK;
	}

/*
 *  update_wnd -- ɥ򹹿롣
 *
 *    : ɬפʤ TRUE ֤
 */

static BOOL
update_wnd (T_TCP_HDR *tcph, T_TCP_CEP *cep)
{

	/*
	 *  
	 *
	 *    ACK ե饰åȤƤ &&
	 *    (󥦥ɤ򹹿 SEQ (snd_wl1)  SEQ  ||
	 *     󥦥ɤ򹹿 SEQ (snd_wl1)  SEQ Ʊ &&
	 *     (󥦥ɤ򹹿 ACK (snd_wl2)  ACK  ||
	 *      (󥦥ɤ򹹿 ACK (snd_wl2)  ACK Ʊ &&
	 *       WIN μǽɥ (snd_wnd) 礭
	 *       )
	 *      )
	 *     )
	 */
	if ((tcph->flags & TCP_FLG_ACK) &&
	    (SEQ_LT(cep->snd_wl1, tcph->seq) ||
	     (cep->snd_wl1 == tcph->seq &&
	      (SEQ_LT(cep->snd_wl2, tcph->ack) ||
	       (cep->snd_wl2 == tcph->ack && tcph->win > cep->snd_wnd))))) {

		cep->snd_wnd = tcph->win;
		cep->snd_wl1 = tcph->seq;
		cep->snd_wl2 = tcph->ack;

		if (cep->snd_wnd > cep->max_sndwnd)
			/* ޤǤκɥ򹹿롣*/
			cep->max_sndwnd = cep->snd_wnd;

#ifdef TCP_CFG_SWBUF_CSAVE

		if ((cep->flags & TCP_CEP_FLG_WBCS_MASK) == TCP_CEP_FLG_WBCS_WOPEN_PEND) {

			/*
			 *  ɥХåեѤΥͥåȥХåեǡ
			 *  μɤΤԤäƤȤν
			 */
			if (cep->snd_wnd > 0) {

				/*
				 *  μɤȤϡ
				 *  ɥХåեѤΥͥåȥХåեƤƳ롣
				 */
				cep->flags = (cep->flags & ~TCP_CEP_FLG_WBCS_MASK)
				                         |  TCP_CEP_FLG_WBCS_FREE |  TCP_CEP_FLG_POST_OUTPUT;
				sig_sem(SEM_TCP_POST_OUTPUT);
				}
			}

#endif	/* of #ifdef TCP_CFG_SWBUF_CSAVE */

		return TRUE;
		}
	else
		return FALSE;
	}

/*
 *  proc_urg -- ۵ޥǡĤΥȤν
 */

#ifdef TCP_CFG_EXTENTIONS

static void
proc_urg (T_TCP_HDR *tcph, T_TCP_CEP *cep)
{
	if ((tcph->flags & TCP_FLG_URG) && VALID_URG_POINTER(tcph->urp) &&
	    TCP_FSM_HAVE_RCVD_FIN(cep->fsm_state) == 0) {

		/* ۵ޥǡĤΥȤν */

		NET_COUNT_TCP(net_count_tcp[NC_TCP_RECV_URG_SEGS], 1);
		if (tcph->urp + cep->rwbuf_count > cep->rbufsz) {

			/*
			 *  ۵ޥݥ󥿤ΰ֤ɥХåե
			 *  ϰϤĶȤϲ⤷ʤ
			 */
			tcph->urp    = 0;
			tcph->flags &= ~TCP_FLG_URG;
			}

		if (SEQ_GT(tcph->seq + tcph->urp, cep->rcv_up))
			/* ۵ޥݥ󥿤줿Ȥν */
			cep->rcv_up = tcph->seq + tcph->urp;

		if ((tcph->flags & TCP_FLG_URG) && (tcph->urp + TCP_CFG_URG_OFFSET) < tcph->sum) {	/* tcph->sum  TCP  SDU Ĺ */

			/*
			 *  ۵ޥݥ󥿤ΰ֤ξϡ
			 *  ХåؿƤӽФ
			 */
			cep->urg_tcph = tcph;
			if (IS_PTR_DEFINED(cep->callback)) {
				(*cep->callback)(GET_TCP_CEPID(cep), TEV_TCP_RCV_OOB, (VP)1);
				}
			else {
				syslog(LOG_WARNING, "[TCP] no call back for OOB, CEP: %d.", GET_TCP_CEPID(cep));
				}

			if (cep->urg_tcph != NULL) {
				/* Хåؿ tcp_rcv_oob() ƽФʤä*/
				cep->urg_tcph = NULL;
				tcph->urp = 0;
				}
			else {
				/* 
				 *  Хåؿ tcp_rcv_oob() ƽФϡ
				 *  SDU Ĺͤꤹ롣
				 */
				tcph->urp = 1;
				}
			}
		else if (tcph->urp > 0) {
			tcph->urp = 0;
			}

		}
	else if (SEQ_GT(cep->rcv_nxt, cep->rcv_up)) {
		cep->rcv_up = cep->rcv_nxt;
		tcph->urp = 0;
		}
	}

#else	/* of #ifdef TCP_CFG_EXTENTIONS */

static void
proc_urg (T_TCP_HDR *tcph, T_TCP_CEP *cep)
{
	tcph->urp = 0;
	}

#endif	/* of #ifdef TCP_CFG_EXTENTIONS */

/*
 *  drop_after_ack -- Ȥ˴塢ACK ֤ (: ̾ȤϹäƤʤ)
 *
 *    :
 *      RET_RETURN	꥿󤹤롣
 *	RET_RST_DROP	顼RST Ȥ˴롣
 */

static ER
drop_after_ack (T_NET_BUF *input, T_TCP_CEP *cep, UINT thoff)
{
	T_TCP_HDR *tcph = GET_TCP_HDR(input, thoff);

	/*
	 *    SYN ֤ǡACK ãǧƤʤǾ SEQ (snd_una) 
	 *    ͤ줿 SEQ (snd_max) ͤξϡ RST 
	 *    äƽλ롣ϡ"LAND" DoS ؤɸǤꡢ¤줿 SYN
	 *    ȤĤŤݡȴ֤Ǥ ACK ȡɤ
	 */
	if (cep->fsm_state == TCP_FSM_SYN_RECVD && (tcph->flags & TCP_FLG_ACK) &&
	    (SEQ_GT(cep->snd_una, tcph->ack) ||
	     SEQ_GT(tcph->ack, cep->snd_max)))
		return RET_RST_DROP;

	syscall(rel_net_buf(input));

	/* ؼ롣*/
	cep->flags |=  TCP_CEP_FLG_ACK_NOW | TCP_CEP_FLG_POST_OUTPUT;
	sig_sem(SEM_TCP_POST_OUTPUT);
	return RET_RETURN;
	}

/*
 *  close_connection -- ꤫ͥ FIN 
 */

static void
close_connection (T_TCP_CEP *cep, BOOL *needoutput)
{
	if (TCP_FSM_HAVE_RCVD_FIN(cep->fsm_state) == 0) {

#ifdef TCP_CFG_DELAY_ACK

		if (cep->flags & TCP_CEP_FLG_NEED_SYN)
			cep->flags |= TCP_CEP_FLG_DEL_ACK;
		else
			cep->flags |= TCP_CEP_FLG_ACK_NOW;

#else/* of #ifdef TCP_CFG_DELAY_ACK */

		cep->flags |= TCP_CEP_FLG_ACK_NOW;

#endif/* of #ifdef TCP_CFG_DELAY_ACK */

		cep->rcv_nxt ++;
		}

	switch (cep->fsm_state) {
	case TCP_FSM_SYN_RECVD:		/* SYN SYN Ѥ	*/
	case TCP_FSM_ESTABLISHED:	/* ͥߴλ		*/
		cep->fsm_state = TCP_FSM_CLOSE_WAIT;
		break;

	case TCP_FSM_FIN_WAIT_1:	/* APP λFIN ѤߡACK Ԥ */
		cep->fsm_state = TCP_FSM_CLOSING;
		break;

	case TCP_FSM_FIN_WAIT_2:	/* ꤫ FIN Ԥ */
		cep->fsm_state = TCP_FSM_TIME_WAIT;
		tcp_cancel_timers(cep);
		cep->timer[TCP_TIM_2MSL] = 2 * TCP_TVAL_MSL;

		/*
		 *  FIN WAIT 2 ֤Ǥϡ
		 *  ϲǽǤ뤬ǤϽλƤ롣
		 *  ⽪λΤǡϥΤߵ롣
		 */
		syscall(set_flg(cep->snd_flgid, CEP_EVT_SWBUF_READY));

#if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0

		/* ꤫ FIN ФƱ֤*/
		tcp_respond(NULL, cep, cep->rcv_nxt, cep->snd_una,
		            cep->rbufsz - cep->rwbuf_count, TCP_FLG_ACK);
		cep->flags &= ~TCP_CEP_FLG_ACK_NOW;
		*needoutput = FALSE;

		/*
		 *  ɬפʾ Time Wait  TCP ̿ü˰ܤơ
		 *  ɸ TCP ̿ü롣
		 */
		tcp_move_twcep(cep);

#endif	/* of #if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0 */

		break;

	case TCP_FSM_TIME_WAIT:		/* ꤫ FIN ѤߡԤ */
		cep->timer[TCP_TIM_2MSL] = 2 * TCP_TVAL_MSL;
		break;
		}
	}

/*
 *  tcp_input -- TCP ϴؿ
 *
 *	: input ˤ IF إå IP إåƬˤ롣
 */

UINT
tcp_input (T_NET_BUF **inputp, UINT *offp, UINT *nextp)
{
	T_NET_BUF	*input = *inputp;
	T_IP_HDR	*iph;
	T_TCP_HDR	*tcph;
	T_TCP_CEP	*cep = NULL;
	T_TCP_SEQ	iss = 0;
	W		todrop, win;
	ER		ret;
	BOOL		needoutput = FALSE;
	UH		seglen;
	UB		flags;

#if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0
	T_TCP_TWCEP	*twcep;
#endif	/* of #if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0 */

	NET_COUNT_TCP(net_count_tcp[NC_TCP_RECV_OCTETS],
	              input->len - GET_IF_IP_HDR_SIZE(input));
	NET_COUNT_TCP(net_count_tcp[NC_TCP_RECV_SEGS], 1);
	NET_COUNT_MIB(tcp_stats.tcpInSegs, 1);

	/* إåĹå롣*/
	if (input->len < IF_IP_TCP_HDR_SIZE) {
		NET_COUNT_TCP(net_count_tcp[NC_TCP_RECV_BAD_HEADERS], 1);
		goto drop;
		}

	iph  = GET_IP_HDR(input);
	tcph = GET_TCP_HDR(input, *offp);

	seglen  = input->len - *offp;				/* TCP ΥĹ */

	if (IN_CKSUM(input, IPPROTO_TCP, *offp, (UINT)seglen) != 0) {
		NET_COUNT_TCP(net_count_tcp[NC_TCP_RECV_BAD_CKSUMS], 1);
		goto drop;
		}

	/* TCP إåĹå롣*/
	if (TCP_HDR_LEN(tcph->doff) < TCP_HDR_SIZE || TCP_HDR_LEN(tcph->doff) > seglen) {
		NET_COUNT_TCP(net_count_tcp[NC_TCP_RECV_BAD_HEADERS], 1);
		goto drop;
		}
	tcph->sum = seglen - TCP_HDR_LEN(tcph->doff);		/*  tcph->sum  TCP  SDU Ĺ */

	/*
	 *  SYN  FIN ξӥåȤåȤƤ˴롣nmap к
	 *  RFC1644 T/TCP ĥǽȶ礹롣
	 */
	if ((tcph->flags & (TCP_FLG_SYN | TCP_FLG_FIN)) == (TCP_FLG_SYN | TCP_FLG_FIN))
		goto drop;

	/* ͥåȥۥȥѴ롣*/

	NTOHL(tcph->seq);
	NTOHL(tcph->ack);
	NTOHS(tcph->win);
	NTOHS(tcph->urp);
	NTOHS(tcph->sport);
	NTOHS(tcph->dport);

find_cep:

#if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0

	/*
	 *  ֤ Time Wait  CEP õ롣
	 */
	twcep = tcp_find_twcep(&iph->dst, tcph->dport, &iph->src, tcph->sport);
	if (twcep != NULL) {

		if (tcph->flags & TCP_FLG_RST)		/* RST ե饰Ȥ̵뤹롣*/
			goto drop;
		else {

			/*
			 *    TCP ̿ü Time Wait λۥȤ饻Ȥ褿Ȥϡ
			 *    ۥȤ FIN Ф뼫ۥȤ ACK Ȥ
			 *    »Ȥ̣ƤΤǡACK Ȥ롣
			 */
			tcp_respond(input, NULL, twcep->rcv_nxt, twcep->snd_una, twcep->rbufsz - twcep->rwbuf_count, TCP_FLG_ACK);
			}
		return IPPROTO_DONE;
		}
	else
		/* ɸ TCP ̿ü롣*/
		cep = tcp_find_cep(&iph->dst, tcph->dport, &iph->src, tcph->sport);

#else	/* of #if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0 */

	/* TCP ̿ü롣*/
	cep = tcp_find_cep(&iph->dst, tcph->dport, &iph->src, tcph->sport);

#endif	/* of #if defined(NUM_TCP_TW_CEP_ENTRY) && NUM_TCP_TW_CEP_ENTRY > 0 */

	/*
	 *  TCP ̿üʤ CEP ξ֤ʤ˴롣
	 */
	if (cep == NULL) {
		syslog(LOG_INFO, "[TCP] unexp port: %d.", tcph->dport);
		goto reset_drop;
		}

#ifdef TCP_CFG_TRACE

	tcp_input_trace(input, cep);

#endif	/* of #ifdef TCP_CFG_TRACE */


	if (cep->fsm_state == TCP_FSM_CLOSED)
		goto drop;

	/*
	 *  ͥߺѤߤǥȤȤϡ
	 *  ɥ֤¸ǧޤꥻåȤ롣
	 */
	cep->idle = 0;
	if (TCP_FSM_HAVE_ESTABLISHED(cep->fsm_state)) {
		cep->timer[TCP_TIM_KEEP] = TCP_TVAL_KEEP_IDLE;
		}

	/* CEP ξ֤ LISTEN ʳλϡץ롣*/
	if (cep->fsm_state != TCP_FSM_LISTEN)
		parse_option(tcph, cep);

	/*
	 *  ǽɥ׻롣
	 *
	 *  rcv_nxt:     ԤƤǾ SEQʤϼѤߡ
	 *  rcv_adv:     ԤƤ SEQ
	 *  rbufsz:      ɥХåե
	 *  rwbuf_count:  ɥХåեˤǡ
	 *  tcph->sum:    SDU 
	 *
	 *  Ȥ󥭥塼Ϣ뤹
	 *  ǽΤ tcph->sum θ롣
	 *
	 */
	win = cep->rbufsz - (cep->rwbuf_count + tcph->sum);
	if (win < 0)
		win = 0;
	if (win > (W)(cep->rcv_adv - cep->rcv_nxt))
		cep->rcv_wnd = win;
	else
		cep->rcv_wnd = cep->rcv_adv - cep->rcv_nxt;

	/* CEP ξ֤ˤԤ*/

	if (cep->fsm_state == TCP_FSM_LISTEN) {		/* ưץ (LISTEN) ν*/
		if ((ret = listening(input, cep, *offp, iss)) == RET_RST_DROP)
			goto reset_drop;
		else if (ret == RET_DROP)
			goto drop;
		trim_length(tcph, cep);			/*  SDU ĹĴ롣*/

		if (tcph->flags & TCP_FLG_ACK) {	/* ACK ե饰ν */
			if ((ret = proc_ack2(input, cep, *offp, &needoutput)) == RET_DROP)
				goto drop;
			else if (ret == RET_RST_DROP)
				goto reset_drop;
			else if (ret == RET_RETURN)
				return IPPROTO_DONE;
			}
		}
	else if (cep->fsm_state == TCP_FSM_SYN_SENT) {	/* ǽưץSYN Ѥ	*/
		if ((ret = syn_sent(tcph, cep)) == RET_RST_DROP)
			goto reset_drop;
		else if (ret == RET_DROP)
			goto drop;
		trim_length(tcph, cep);			/*  SDU ĹĴ롣*/

		if (tcph->flags & TCP_FLG_ACK) {	/* ACK ե饰ν */
			if ((ret = proc_ack2(input, cep, *offp, &needoutput)) == RET_DROP)
				goto drop;
			else if (ret == RET_RST_DROP)
				goto reset_drop;
			else if (ret == RET_RETURN)
				return IPPROTO_DONE;
			}
		}
	else {
		if (cep->fsm_state == TCP_FSM_SYN_RECVD) {	/* SYN SYN Ѥ	*/
			/*
			 *  ꤫ǧƤ⡢
			 *
			 *    ACK <= ̤ǧκǾ SEQ (snd_una) &&
			 *                SEQ (snd_max) < ACK
			 *
			 *  ʤ顢ꥻåȤäƥȤ˴롣
			 */
			if ((tcph->flags & TCP_FLG_ACK) &&
			    (SEQ_LE(tcph->ack, cep->snd_una) ||
			     SEQ_GT(tcph->ack, cep->snd_max)))
			     	goto reset_drop;
			}

		/* 
		 *  RST ե饰Ȥν (۾)
		 */
		if (tcph->flags & TCP_FLG_RST) {
			if (SEQ_GE(tcph->seq, cep->last_ack_sent) &&
			    SEQ_LT(tcph->seq, cep->last_ack_sent + cep->rcv_wnd)) {
				/*
				 *  Ȥ SEQ Ǹ ACK (last_ack_sent)
				 *  顢ɥޤǤδ֤ν
				 */
				switch (cep->fsm_state) {
				case TCP_FSM_SYN_RECVD:		/* SYN SYN Ѥ		*/

					cep->net_error = EV_CNNRF;	/* ³ǽ */
					cep->error     = E_CLS;
					NET_COUNT_TCP(net_count_tcp[NC_TCP_RECV_RSTS], 1);
					NET_COUNT_MIB(tcp_stats.tcpAttemptFails, 1);
					cep = tcp_close(cep);
					break;

				case TCP_FSM_ESTABLISHED:	/* ͥߴλ			*/
				case TCP_FSM_CLOSE_WAIT:	/* FIN Ԥ		*/
					NET_COUNT_MIB(tcp_stats.tcpEstabResets, 1);
					/* fallthrough */

				case TCP_FSM_FIN_WAIT_1:	/* λơFIN Ѥ		*/
				case TCP_FSM_FIN_WAIT_2:	/* λFIN ãǧFINԤ	*/

					cep->net_error = EV_CNRST;	/* ³ꥻå */
					cep->error     = E_CLS;
					NET_COUNT_TCP(net_count_tcp[NC_TCP_RECV_RSTS], 1);
					/* no break; */

				case TCP_FSM_CLOSING:		/* λFIN 򴹺ѤߡACK Ԥ	*/
				case TCP_FSM_LAST_ACK:		/* FIN λACK Ԥ	*/

					cep = tcp_close(cep);
					break;
					}
				}
			goto drop;
			}

		/*
		 *  CEP ξ֤ SYN SYN Ѥߤξϡ
		 *  ɤ˼ޤ褦˥ǡ
		 *  Ĵˡ³ˤѥåȤɤ򸡾ڤ롣
		 *
		 *     SEQ <  SEQ ν (irs)
		 *
		 *  ϡ"LAND" DoS ɸǤ롣
		 */
		if (cep->fsm_state == TCP_FSM_SYN_RECVD && SEQ_LT(tcph->seq, cep->irs)) {
			goto reset_drop;
			}

		/*
		 *  ԤƤǾ SEQ (rcv_nxt) -  SEQ 
		 *  ʤ顢rcv_nxt ΥǡϤǤ˼ƤΤǡʬ
		 *  롣
		 *                           <---------- rcv_wnd --------->
		 *                           rcv_nxt                      rcv_nxt + rcv_wnd
		 *                           v                            v
		 *                      -----+----------------------------+-----
		 *                           |                            |
		 *                      -----+----------------------------+-----
		 *           +----------------------+
		 *           |***************|      |
		 *           +----------------------+
		 *           ^                      ^
		 *           seq                    seq + len
		 *           <---------------> 롣
		 */
		todrop = cep->rcv_nxt - tcph->seq;
		if (todrop > 0) {

			/*
			 *  SYN ե饰ĤƤȤϡʬ (1 ƥå)
			 *  SEQ ʤᡢ۵ޥݥ󥿤ȺĹĴ롣
			 */
			if (tcph->flags & TCP_FLG_SYN) {
				tcph->flags &= ~TCP_FLG_SYN;
				tcph->seq ++;
				if (tcph->urp > 1)
					tcph->urp --;
				else
					tcph->flags &= ~TCP_FLG_URG;
				todrop --;
				}

			/*
			 *  Ĺ SDU ĹĤޤꡢԤƤ
			 *  Ǿ SEQ (rcv_nxt) ãƤʤ
			 *  Ĺ SDU ƱǡFIN ե饰ĤƤʤ
			 *  ƺ롣
			 */
			if ( todrop >  tcph->sum ||		/* tcph->sum  TCP  SDU Ĺ */
			    (todrop == tcph->sum && (tcph->flags & TCP_FLG_FIN) == 0)) {
				tcph->flags &= ~TCP_FLG_FIN;
				cep->flags |= TCP_CEP_FLG_ACK_NOW;
				todrop = tcph->sum;		/* tcph->sum  TCP  SDU Ĺ */
				}

			/*
			 *  SDU ˵ͤ롣
			 */
			if (todrop < tcph->sum) {		/* tcph->sum  TCP  SDU Ĺ */
				memcpy(GET_TCP_SDU(input, *offp),
				       GET_TCP_SDU(input, *offp) + todrop, (size_t)(tcph->sum - todrop));
				}

			/*
			 *  SEQ  SDU ĹĴ롣
			 */
			tcph->seq +=     todrop;
			tcph->sum -= (UH)todrop;	/* tcph->sum  TCP  SDU Ĺ */

			/*
			 *  ۵ޥݥ󥿤Ĵ롣
			 */
			if (tcph->urp > todrop)
				tcph->urp -= (UH)todrop;
			else {
				tcph->flags &= ~TCP_FLG_URG;
				tcph->urp = 0;
				}

			NET_COUNT_TCP(net_count_tcp[NC_TCP_RECV_DUP_SEGS], 1);
			}

		/*  
		 *  ⤷桼λˡǡ
		 *  ϡRST 롣
		 */
		if (cep->fsm_state == TCP_FSM_LAST_ACK && tcph->sum > 0) {	/* tcph->sum  TCP  SDU Ĺ */
			cep = tcp_close(cep);
			goto reset_drop;
			}

		/*
		 *  ȤɤĶϡ
		 *  Ķʬ롣
		 *
		 *       <---------- rcv_wnd --------->
		 *       rcv_nxt                      (rcv_nxt + rcv_wnd)
		 *       v                            v
		 *  -----+----------------------------+-----
		 *       |                            |
		 *  -----+----------------------------+-----
		 *                    +----------------------+
		 *                    |               |******|
		 *                    +----------------------+
		 *                    ^                      ^
		 *                    seq                    seq + len
		 *                                     <-----> 롣
		 */
		todrop = (tcph->seq + tcph->sum) - (cep->rcv_nxt + cep->rcv_wnd);	/* tcph->sum  TCP  SDU Ĺ */
		if (todrop > 0) {
			if (todrop > tcph->sum) {					/* tcph->sum  TCP  SDU Ĺ */
				/*
				 *   SDU ƤɤĶ硣
				 *
				 *  TIME_WAIT ˡ³׵
				 *  Ť³˴³򳫻Ϥ롣
				 *  SEQ ʤǤʤФʤʤ
				 */
				if ((tcph->flags & TCP_FLG_SYN) &&
				    cep->fsm_state == TCP_FSM_TIME_WAIT &&
				    SEQ_GT(tcph->seq, cep->rcv_nxt)) {
					iss = cep->snd_nxt + TCP_ISS_INCR();
					tcp_close(cep);
					syscall(dly_tsk(0));
					goto find_cep;
				    	}

				/*
				 *  ɤ 0 ǡ SEQ 
				 *  ԤƤǾ SEQ פȤ
				 *  ACK ֤ʳϥǡ˴ACK ֤
				 */
				if (cep->rcv_wnd == 0 && (tcph->seq == cep->rcv_nxt || tcph->sum == 0)) {
					cep->flags |= TCP_CEP_FLG_ACK_NOW;
					}
				else if (drop_after_ack(input, cep, *offp) == RET_RST_DROP)
					goto reset_drop;
				else {
					return IPPROTO_DONE;
					}
				}
			tcph->sum -= (UH)todrop;	/* tcph->sum  TCP  SDU Ĺ */
			tcph->flags &= ~(TCP_FLG_PUSH | TCP_FLG_FIN);
			}

		/*
		 *  ⤷SYN åȤƤС
		 *  顼ʤΤ RST ꡢ³˴롣
		 */
		if (tcph->flags & TCP_FLG_SYN) {
			cep->net_error = EV_CNRST;
			cep = tcp_drop(cep, E_CLS);
			goto reset_drop;
			}

		/*
		 *  ⤷ACK åȤƤʤϡ
		 *  ֤ SYN Ѥߤ
		 *  SYN 褦ȤƤС³뤬
		 *  ʳϥȤ˴ƽλ롣
		 */
		if ((tcph->flags & TCP_FLG_ACK) == 0) {
			if (!(cep->fsm_state == TCP_FSM_SYN_RECVD || (cep->flags & TCP_CEP_FLG_NEED_SYN)))
				goto drop;
			}
		else {
			/*
			 * ACK ν
			 */
			ret = proc_ack1(input, cep, *offp, &needoutput);
			if (ret == RET_DROP)
				goto drop;
			else if (ret == RET_RST_DROP)
				goto reset_drop;
			else if (ret == RET_RETURN)
				return IPPROTO_DONE;
			}
		}

/* step 6 */

	/* ɤ򹹿롣*/
	if (update_wnd(tcph, cep) == TRUE)
		needoutput = TRUE;

	/* ۵ޥǡ롣*/
	proc_urg(tcph, cep);

/* do data */

	/*
	 *  SDU 뤫FIN ̤ξ֤ǡǽ FIN Ȥ
	 *  ȥ塼 net_buf ɲä롣
	 *  ʳξϡȤ˴롣
	 */
	flags = tcph->flags;
	if ((tcph->sum > 0 || (flags & TCP_FLG_FIN)) &&		/* tcph->sum  TCP  SDU Ĺ */
	    TCP_FSM_HAVE_RCVD_FIN(cep->fsm_state) == 0) {
		flags = reassemble(input, cep, *offp, flags);
		}
	else {
		syscall(rel_net_buf(input));
		flags &= ~TCP_FLG_FIN;
		}

	/*
	 *  FIN 饳ͥ򥯥롣
	 */
	if (flags & TCP_FLG_FIN)
		close_connection(cep, &needoutput);

	/* ϤԤä彪λ롣*/
	if (needoutput == TRUE || (cep->flags & TCP_CEP_FLG_ACK_NOW)) {
		/* ؼ롣*/
		cep->flags |=  TCP_CEP_FLG_POST_OUTPUT;
		sig_sem(SEM_TCP_POST_OUTPUT);
		}

	return IPPROTO_DONE;

reset_drop:
	/*
	 *  RST 
	 */

	if ((tcph->flags & TCP_FLG_RST) || IN_IS_NET_ADDR_MULTICAST(&iph->dst))
		goto drop;

	/* ۥȥͥåȥ᤹*/

	HTONS(tcph->sport);
	HTONS(tcph->dport);

	if (tcph->flags & TCP_FLG_ACK) {
		tcp_respond(input, cep, 0, tcph->ack, cep->rbufsz - cep->rwbuf_count, TCP_FLG_RST);
		}
	else {
		if (tcph->flags & TCP_FLG_SYN)
			tcph->sum ++;		/* tcph->sum  SDU Ĺ */
		tcp_respond(input, cep, tcph->seq + tcph->sum, 0,
		            cep->rbufsz - cep->rwbuf_count, TCP_FLG_RST | TCP_FLG_ACK);
		}

	/* input  tcp_respoond ֵѤ롣*/
	NET_COUNT_TCP(net_count_tcp[NC_TCP_SEND_RSTS], 1);
	NET_COUNT_MIB(tcp_stats.tcpOutRsts, 1);
	return IPPROTO_DONE;

drop:
	NET_COUNT_TCP(net_count_tcp[NC_TCP_RECV_DROP_SEGS], 1);
	NET_COUNT_MIB(tcp_stats.tcpInErrs, 1);
	syscall(rel_net_buf(input));
	return IPPROTO_DONE;
	}

#endif	/* of #ifdef SUPPORT_TCP */
